﻿''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright (c) Datacard Corporation.  All Rights Reserved.
'
' xps card printer SDK: vb.net 'control' sample
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Imports System.Threading
Imports dxp01sdk

Public Enum Commands
    undefined
    cancellalljobs
End Enum

Public Class CommandLineOptions
    Public printerName As String
    Public command As Commands
End Class

Class control
    Private Shared Sub Usage()
        Console.WriteLine()
        Console.WriteLine("printer_control.exe controls the printer through the printer driver.")
        Console.WriteLine()
        Console.WriteLine("printer_control.exe -n <printername> <command>")
        Console.WriteLine("  -n <printername>. Required. Try -n ""XPS Card Printer"".")
        Console.WriteLine("  -c cancel all jobs: Send a command to the printer to clear any print job")
        Console.WriteLine("                    from the printer. This does not delete spooled Windows")
        Console.WriteLine("                    print jobs.")
        Console.WriteLine()
        Environment.Exit(-1)
    End Sub

    Private Shared Function GetCommandlineOptions(args As String()) As CommandLineOptions
        Dim commandLineOptions As New CommandLineOptions()
        Dim arguments As New CommandLine.Utility.Arguments(args)

        If String.IsNullOrEmpty(arguments("n")) Then
            Usage()
        End If

        ' check for -n with no printer name:
        Dim boolVal As Boolean = False
        If Boolean.TryParse(arguments("n"), boolVal) Then
            Usage()
        End If
        commandLineOptions.printerName = arguments("n")

        If Not String.IsNullOrEmpty(arguments("c")) Then
            commandLineOptions.command = Commands.cancellalljobs
        End If

        If (Commands.undefined = commandLineOptions.command) Then
            Usage()
        End If

        Return commandLineOptions
    End Function

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' CancelAllJobs()
    '
    ' using the IBidiSpl interface, issue a 'cancel all jobs' command. This is
    ' simply a dxp01sdk::Cancel with both printerJobID and errorCode set to zero.
    '
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Private Shared Sub CancelAllJobs(bidiSpl As BidiSplWrap)
        Dim xmlFormat As String = strings.PRINTER_ACTION_XML
        Dim input As String = String.Format(xmlFormat, CInt(Actions.Cancel), 0, 0)
        bidiSpl.SetPrinterData(strings.PRINTER_ACTION, input)
    End Sub

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Main()
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Shared Sub Main(args As String())
        Dim commandLineOptions As CommandLineOptions = GetCommandlineOptions(args)

        Dim bidiSpl As New BidiSplWrap()
        bidiSpl.BindDevice(commandLineOptions.printerName)

        If Commands.cancellalljobs = commandLineOptions.command Then
            CancelAllJobs(bidiSpl)
            Console.WriteLine("all jobs canceled for '{0}'", commandLineOptions.printerName)
        End If

        bidiSpl.UnbindDevice()
    End Sub
End Class
